---
title: Cache.matchAll()
slug: Web/API/Cache/matchAll
tags:
  - API
  - Cache
  - Experimental
  - Method
  - Reference
  - Service Workers
  - ServiceWorker
  - matchAll
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>matchAll()</code></strong> method of the {{domxref("Cache")}} interface returns a {{jsxref("Promise")}} that resolves to an array of all matching responses in the {{domxref("Cache")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>cache</em>.matchAll(<em>request</em>, {<em>options</em>}).then(function(<em>response</em>) {
  // do something with the response array
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>request {{optional_inline}}</dt>
 <dd>The {{domxref("Request")}} for which you are attempting to find responses in the {{domxref("Cache")}}. This can be a <code>Request</code> object or a URL. If this argument is omitted, you will get a copy of all responses in this cache.</dd>
 <dt>options {{optional_inline}}</dt>
 <dd>An options object allowing you to set specific control options for the matching performed. The available options are:
 <ul>
  <li><code>ignoreSearch</code>: A {{jsxref("Boolean")}} that specifies whether the matching process should ignore the query string in the url.  If set to <code>true</code>, the <code>?value=bar</code> part of <code>http://foo.com/?value=bar</code> would be ignored when performing a match. It defaults to <code>false</code>.</li>
  <li><code>ignoreMethod</code>: A {{jsxref("Boolean")}} that, when set to <code>true</code>, prevents matching operations from validating the {{domxref("Request")}} <code>http</code> method (normally only <code>GET</code> and <code>HEAD</code> are allowed.) It defaults to <code>false</code>.</li>
  <li><code>ignoreVary</code>: A {{jsxref("Boolean")}} that when set to <code>true</code> tells the matching operation not to perform <code>VARY</code> header matching — i.e. if the URL matches you will get a match regardless of the {{domxref("Response")}} object having a <code>VARY</code> header or not. It defaults to <code>false</code>.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to an array of all matching responses in the {{domxref("Cache")}} object.</p>

<div class="note">
<p><strong>Note</strong>: {{domxref("Cache.match()")}} is basically identical to <code>Cache.matchAll()</code>, except that rather than resolving with an array of all matching responses, it resolves with the first matching response only (that is, <code><var>response</var>[0]</code>).</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">caches.open('v1').then(function(cache) {
  cache.matchAll('/images/').then(function(response) {
    response.forEach(function(element, index, array) {
      cache.delete(element);
    });
  });
})</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-matchall', 'Cache: matchAll')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Cache.matchAll")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WorkerGlobalScope.caches")}}</li>
</ul>
